<?php
/**
 * @package JLex 360
 * @version 2.1.0
 * @copyright Copyright (C) 2013-2015 JLexArt.com - All rights reserved. (http://www.jlexart.com)
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @author JLexArt Team
 */

// No direct access.
defined ( '_JEXEC' ) or die ();

jimport ( 'joomla.filesystem.folder' );
class plgContentJLex360 extends JPlugin {
	protected $index = 1;
	public function __construct(& $subject, $config) {
		parent::__construct ( $subject, $config );
		$this->loadLanguage ();
	}
	public function isAdmin() {
		$user = JFactory::getUser ();
		if (in_array ( 3, $user->getAuthorisedViewLevels () ))
			return true;
		return false;
	}
	public function onContentPrepare($context, &$row, &$params, $page = 0) {
		$doc = JFactory::getDocument ();
		
		$pattern = '/\{jlex360\}(.+?)\{\/jlex360\}/s';
		$count = 0;
		$row->text = preg_replace_callback ( $pattern, array (
				$this,
				'replace_content' 
		), $row->text, - 1, $count );

		if ($count > 0) {
			// Add css & script at here
			JHtml::_ ( 'jquery.framework');
			$doc->addScript( JUri::base(true).'/plugins/content/jlex360/assets/jlex360.js' );
			$doc->addStyleSheet( JUri::base(true).'/plugins/content/jlex360/assets/css/style.css' );
		}
	}
	public function replace_content($matches) {
		if (! isset ( $matches [1] )) {
			return '';
		}
		$safe = strip_tags(preg_replace('/[\r\n]+/', '', $matches [1]));
		$data = json_decode('{'. $safe .'}');
		if ( !$data || !isset($data->folder) ) {
			return '';
		}
		
		////////// Folder request
		$folder = preg_replace('/^[\/\\\s]*|[\/\\\s]$/','',$data->folder);
		$path = JPATH_ROOT.'/'.$folder;
		if ( !JFolder::exists($path) ) {
			return '';
		}
		$imageLegal = '\.(jpg|jpeg|png|gif|JPG|JPEG|PNG|GIF)$';
		$files = JFolder::files($path,$imageLegal);

		if (!count($files)) return '';
		$first_image = $path.'/'.$files[0];

		foreach ($files as $k=>$file) {
			$filefix = JUri::base(true).'/'.$folder.'/'.$file;
			$files[$k] = $filefix;
		}

		/////////// For zoom
		if (isset($data->zoomfolder)) {
			$zoomfolder = preg_replace('/^[\/\\\s]*|[\/\\\s]$/','',$data->zoomfolder);
			$path = JPATH_ROOT.'/'.$zoomfolder;
			if ( !JFolder::exists($path) ) {
				return '';
			}
			$imageLegal = '\.(jpg|jpeg|png|gif|JPG|JPEG|PNG|GIF)$';
			$files2 = JFolder::files($path,$imageLegal);

			if (!count($files2)) return '';

			foreach ($files2 as $k=>$file) {
				$filefix = JUri::base(true).'/'.$zoomfolder.'/'.$file;
				$files2[$k] = $filefix;
			}
		}


		$setting = new stdClass();
		$setting->nophp = true;
		$setting->id = 'rotateimage_'.$this->index;
		$setting->nophpimglist = implode(',', $files);
		if (count($files2)) {
			$setting->zoom = true;
			$setting->nophpzoomlist = implode(',', $files2);
		} else {
			$setting->zoom = false;
		}
		$setting->autorotate = @!$data->autoplay ? false : true;
		$setting->wheelRotate = @!$data->wheelrotate ? false  : true;
		$setting->autorotatespeed = @!$data->autorotatespeed || $data->autorotatespeed<10 ? 100:intval($data->autorotatespeed);
		$setting->roteteloop = @!$data->roteteloop ? false : true;
		$setting->rotatehover =@!$data->rotatehover ? false : true;
		$setting->disablelogo = true;
		$setting->reverse = @!$data->reverse ? false : true;
		$setting->startfrom = @!$data->startfrom ? 0 : intval($data->startfrom);

		if (!isset($data->width) || !isset($data->height)) {
			list($width, $height, $type, $attr) = getimagesize($first_image);
			$data->width = $width;
			$data->height = $height;
		}

		$setting->width = $data->width;
		$setting->height = $data->height;

		// Language
		$setting->hotspotsTitle = JText::_('PLG_JL360_HIGHLIGHTS');

		// Hotspots
		$hotspots = '';
		if (isset($data->pins) && count($data->pins)) {
			$setting->hotspots = true;
			foreach ($data->pins as $pin) {
				$hotspots .= "\n<a class='sethotspot' href='{$pin->frame}' title='{$pin->title}' posix='{$pin->x}' posiy='{$pin->y}'>{$pin->desc}</a>";
			}
		}

		$setting_json = json_encode($setting);
		
		$html = "<div class=\"jlex360-box\">";
		$html .= "\n<div class=\"dopelessrotate\">";
		$html .= "\n<img id=\"{$setting->id}\" src=\"{$files[0]}\" >";
		$html .= $hotspots;
		$html .= "\n</div>";
		// Insert toolbar
		if (isset($data->toolbar)) {
			ob_start();
			include dirname(__FILE__).'/assets/toolbar.php';
			$output = ob_get_contents();
            ob_end_clean();
            $html .= $output;
		}
		$html .= "\n</div>";

		$html .= "\n<script type=\"text/javascript\">jlex360({$setting_json})</script>";
		
		$this->index ++;
		return $html;
	}
}
